pool/pool.sh

232 lines
4.4 KiB
Bash
Raw Normal View History

2021-08-21 17:43:32 +02:00
#!/usr/bin/env bash
set -e
# Fetch arguments
CMD=$1
2021-08-21 18:24:45 +02:00
if [ $# -gt 1 ]
then
POOL_ID=$2
shift 2
PROC_CMD=$@
fi
2021-08-21 17:43:32 +02:00
# Config: feel free to change at your own risks
2021-08-21 20:42:11 +02:00
TMPDIR=/tmp
POOL_FORMAT="pool_${POOL_ID}"
POOL="${TMPDIR}/${POOL_FORMAT}/"
POOL_STATUS="${POOL}/status"
REFRESH_EVERY=2
2021-08-21 17:43:32 +02:00
abort() {
echo $@
exit 1
}
write_status() {
2021-08-21 20:42:11 +02:00
echo "maxproc=${maxproc}" > "$POOL_STATUS"
echo "nproc=${nproc}" >> "$POOL_STATUS"
echo "procs=\"${procs}\"" >> "$POOL_STATUS"
echo "lastprocid=$lastprocid" >> "$POOL_STATUS"
2021-08-22 13:01:09 +02:00
echo "createdat=$createdat" >> "$POOL_STATUS"
2021-08-21 17:43:32 +02:00
}
2021-08-21 20:42:11 +02:00
create_properties() {
2021-08-22 09:00:50 +02:00
local file="${POOL}/proc_${procid}"
2021-08-21 17:43:32 +02:00
echo cmd=\"${PROC_CMD}\" > "$file"
echo "procpid=${procpid}" >> "$file"
echo "procid=${procid}" >> "$file"
echo "startat=${startat}" >> "$file"
}
setp() {
2021-08-22 09:00:50 +02:00
local file="${POOL}/proc_${procid}"
sed -i "/${1}=/d" "$file"
echo $1=\"$2\" >> "$file"
2021-08-21 17:43:32 +02:00
}
getp() {
2021-08-22 09:00:50 +02:00
local file="${POOL}/proc_${procid}"
value=$(grep "^$1=" "$file"||:)
[ -z "$value" ] && echo "Property $1 not found for process ${procid}" || { echo "$value" | sed "s/^$1=//" | xargs echo; }
2021-08-21 17:43:32 +02:00
}
create() {
2021-08-22 09:00:50 +02:00
[ -d "$POOL" ] && abort "Pool \"$POOL\" already exists" || :
2021-08-22 17:37:21 +02:00
[ ! "$1" -gt 0 ] && abort "Invalid pool capacity $1" || :
2021-08-21 20:42:11 +02:00
mkdir -p "$POOL"
2021-08-21 17:43:32 +02:00
# Write pool status
maxproc=$1
nproc=0
procs=""
lastprocid=0
2021-08-22 13:01:09 +02:00
createdat=$(date +"%s")
2021-08-21 17:43:32 +02:00
write_status
}
remove() {
2021-08-21 18:06:52 +02:00
refresh # Refresh process status and load status
2021-08-22 09:00:50 +02:00
[ $nproc -gt 0 ] && abort "Processes are still running in the pool!" || :
2021-08-21 20:42:11 +02:00
rm -rf "$POOL"
2021-08-21 17:43:32 +02:00
}
refresh() {
2021-08-21 20:42:11 +02:00
source "$POOL_STATUS"
2021-08-21 17:43:32 +02:00
procs_new=""
for proc in $procs
do
if kill -0 $proc &>/dev/null
then
[ -z "$procs_new" ] && procs_new="$proc" || procs_new="$procs_new $proc"
fi
done
procs=$procs_new
nproc=$(echo "$procs"|wc -w)
write_status
}
run() {
refresh
2021-08-21 18:06:52 +02:00
# Wait for room in the pool
2021-08-21 17:43:32 +02:00
while [ $nproc -ge $maxproc ]
do
sleep $REFRESH_EVERY
refresh
done
2021-08-21 18:06:52 +02:00
# Create new process
2021-08-21 17:43:32 +02:00
nproc=$(( nproc + 1 ))
procid=$(( lastprocid + 1 ))
lastprocid=$procid
startat=$(date +"%s")
2021-08-22 09:00:50 +02:00
$PROC_CMD &> "$POOL/out_$procid" &
2021-08-21 17:43:32 +02:00
procpid=$!
[ -z "$procs" ] && procs="$procpid" || procs="$procs $procpid"
2021-08-21 18:06:52 +02:00
write_status # Update status
2021-08-21 20:42:11 +02:00
create_properties # Create process properties
2021-08-21 18:06:52 +02:00
echo $procid # Return process id
2021-08-21 17:43:32 +02:00
}
cat_output() {
2021-08-22 09:00:50 +02:00
local file="${POOL}/out_${procid}"
2021-08-21 17:43:32 +02:00
cat "$file"
}
2021-08-21 18:24:45 +02:00
list_pool() {
2021-08-22 13:01:09 +02:00
find "${TMPDIR}" -maxdepth 1 -name "${POOL_FORMAT}*" -type d -exec basename {} \; 2>/dev/null | sed "s/${POOL_FORMAT}//g"
2021-08-21 18:24:45 +02:00
}
2021-08-21 17:43:32 +02:00
wait_pool() {
refresh
while [ $nproc -gt 0 ]
do
sleep $REFRESH_EVERY
refresh
done
}
2021-08-22 10:28:30 +02:00
status() {
refresh
cat "${POOL_STATUS}"
}
2021-08-21 17:43:32 +02:00
list_output() {
refresh
2021-08-21 20:42:11 +02:00
find "${POOL}" -name "out_*"
2021-08-21 17:43:32 +02:00
}
remove_force() {
refresh
for proc in $procs
do
kill -9 $proc
done
2021-08-21 20:42:11 +02:00
rm -rf "$POOL"
2021-08-21 17:43:32 +02:00
}
2021-08-22 09:00:50 +02:00
check_pool() {
if [ ! -d "$POOL" ]; then abort "Pool ${POOL_ID} not found"; fi
if [ ! -f "$POOL_STATUS" ]; then abort "Pool ${POOL_ID} corrupted: status file not found"; fi
if [ $# -gt 0 ]
then
[ ! -f "${POOL}/proc_${1}" ] && echo abort "Process $1 does not exists in pool ${POOL_ID}" || :
fi
}
pause() {
refresh
for proc in $procs
do
kill -STOP $proc
done
}
resume() {
refresh
for proc in $procs
do
kill -CONT $proc
done
}
2021-08-21 17:43:32 +02:00
# Launch command
case "$CMD" in
"create")
create $1
;;
"remove")
2021-08-22 09:00:50 +02:00
check_pool
2021-08-21 17:43:32 +02:00
remove
;;
"run")
2021-08-22 09:00:50 +02:00
check_pool
2021-08-21 17:43:32 +02:00
run
;;
"cat")
2021-08-22 09:00:50 +02:00
check_pool $1
2021-08-21 17:43:32 +02:00
procid=$1
refresh
2021-08-22 09:00:50 +02:00
[ $procid -gt $lastprocid ] && abort "Processus $procid not found" || cat_output
2021-08-21 17:43:32 +02:00
;;
2021-08-21 18:24:45 +02:00
"ls-output")
2021-08-22 09:00:50 +02:00
check_pool
2021-08-21 17:43:32 +02:00
list_output
;;
2021-08-21 18:24:45 +02:00
"ls")
list_pool
;;
2021-08-21 17:43:32 +02:00
"wait")
2021-08-22 09:00:50 +02:00
check_pool
2021-08-21 17:43:32 +02:00
wait_pool
;;
"remove-force")
2021-08-22 09:00:50 +02:00
check_pool
2021-08-21 17:43:32 +02:00
remove_force
;;
"setp")
2021-08-22 09:00:50 +02:00
check_pool $1
2021-08-21 17:43:32 +02:00
procid=$1
setp $2 $3
;;
"getp")
2021-08-22 09:00:50 +02:00
check_pool $1
2021-08-21 17:43:32 +02:00
procid=$1
getp $2
;;
2021-08-22 09:00:50 +02:00
"pause")
check_pool
pause
;;
"resume")
check_pool
resume
;;
2021-08-22 10:28:30 +02:00
"status")
check_pool
status
;;
2021-08-21 17:43:32 +02:00
*)
abort "Command $CMD unknown"
esac
2021-08-22 09:00:50 +02:00